React UI Components Documentation
Typescript React BarGauge Component
This tutorial will show you the basics of how to get started with the jQWidgets BarGauge React Component.
Prerequisites
Refer to Getting Started with React before you start with this help topic.
Structure
I. Imports:
import * as React from 'react'; import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';import JqxBarGauge, { IBarGaugeProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxbargauge';
II. Class:
class App extends React.PureComponent<{}, IBarGaugeProps> { constructor(props: {}) { super(props); this.state = { width: '100%' // Other Widget Props } } render() { return ( <JqxBarGauge width={this.state.width} height={"100%"} ..... /> ) }}
III. Render:
ReactDOM.render(<App />, document.getElementById('app'));
Events
The event names in React are constructed of the original event names starting with capital letter plus on upfront:
class App extends React.PureComponent<{}, IBarGaugeProps> { constructor(props: {}) { super(props); this.state = { width: '100%' // Other Widget Props } } render() { return ( <JqxBarGauge onNameOfEvent={this.handleEvent} width={this.state.width} height={"100%"} ..... /> ) } private handleEvent(e: Event): void { // Do Something ... }}
Methods & Properties
This is how you call methods & props:
//Get Methodsconst value = this.myBarGauge.current!.methodName(arg1, arg2); //Set Methodsthis.myBarGauge.current!.methodName(arg1, arg2); //Get Propertiesconst height = this.state.height; //Set Propertiesthis.setState({ height: 250 });
Every component have a method setOptions which accepts a object as an argument. This object contains component settings.
this.myBarGauge.current!.setOptions({ width: 350, height: 400 });
Every component also have a method getOptions which returns the value of the requested option.
const width = this.myBarGauge.current!.getOptions('width');
BarGauge API
API Reference of the jQWidgets BarGauge React Component: BarGauge API
BarGauge Demos
Demos Reference of the jQwidgets BarGauge React Component: BarGauge Demos

Vue UI Components Documentation

Vue BarGauge Component

The BarGauge component for Vue represents data as a set of bars that reside on separate circular tracks.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The BarGauge component for Vue requires the following import:

import JqxBarGauge from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxbargauge.vue';

Add the jqxBarGauge component to the components section of the the Vue class

 components: {
JqxBarGauge
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxBarGauge/>

<template>
<JqxBarGauge :width="500"
:height="600"
:colorScheme="'scheme02'"
:max="150"
:values="values"
:tooltip="tooltip">
</JqxBarGauge>
</template>

Properties

The properties of the <JqxBarGauge/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
tooltip: {
visible: true,
formatFunction: (value) => {
let realVal = parseInt(value);
return ('Year: 2016<br />Price Index:' + realVal);
}
},
values: [102, 115, 130, 137]
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxBarGauge ref="myBarGauge" @drawEnd="onDrawEnd($event)">
</JqxBarGauge>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onDrawEnd: function (event) {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxBarGauge ref="barGauge"></JqxBarGauge>

Here how you can use a component's method:

this.$refs.barGauge.val([10, 20, 30, 40]);

methods: {
// Add here all used callbacks and/or events
onDrawEnd: function (event) {
this.$refs.barGauge.val([10, 20, 30, 40]);
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

<template>
<JqxBarGauge ref="barGauge" @drawEnd="onDrawEnd($event)"
:width="width"
:height="600"
:colorScheme="'scheme02'"
:max="150"
:values="values"
:tooltip="tooltip">
</JqxBarGauge>
</template>
<script>
// Import the components that will be used
import JqxBarGauge from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxbargauge.vue';
export default {
components: {
// Adding imported widgets here
JqxBarGauge
},
data: function () {
// Define properties which will use in the widget
return {
width: 500,
tooltip: {
visible: true,
formatFunction: (value) => {
let realVal = parseInt(value);
return ('Year: 2016<br />Price Index:' + realVal);
}
},
values: [102, 115, 130, 137]
}
},
beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
},
methods: {
// Add here all used callbacks and/or events
onDrawEnd: function (event) {
this.$refs.barGauge.val([10, 20, 30, 40]);
}
}
}
</script>
<style>
</style>

BarGauge Example

<template>
<JqxBarGauge ref="myBarGauge" @drawEnd="onDrawEnd()"
:width="width" :height="600" :relativeInnerRadius="0.6"
:values="[25]" :formatFunction="formatFunction">
</JqxBarGauge>
</template>
<script>
import JqxBarGauge from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxbargauge.vue';
export default {
components: {
JqxBarGauge,
},
data: function () {
return {
width: 500
}
},
methods: {
formatFunction: function (value, index, color) {
let barGaugePalette = ['#307DD7', '#AA4643', '#89A54E', '#71588F', '#4198AF'];
if (value < 20) {
return barGaugePalette[0];
}
if (value < 40) {
return barGaugePalette[1];
}
if (value < 60) {
return barGaugePalette[2];
}
if (value < 80) {
return barGaugePalette[3];
}
if (value <= 100) {
return barGaugePalette[4];
}
},
onDrawEnd: function () {
let values = [this.getRandomInt(1, 99)];
setTimeout(() => {
this.$refs.myBarGauge.val(values);
}, 1000);
},
getRandomInt: function (min, max) {
return Math.floor(Math.random() * (max - min)) + min;
}
}
}
</script>

Run Code

Angular BarGauge Component

The jqxBarGauge component from jqWidgets is a powerful tool for visualizing values in a circular bar format. This guide provides step-by-step instructions and examples for integrating and using jqxBarGauge in Angular applications.

Step 1: Install jqWidgets

Install the jqWidgets library in your Angular project using npm:

npm install jqwidgets-ng --save

Step 2: Add jqx.base.css

To ensure proper styling of the jqxBarGauge component, include the jqWidgets base CSS file in your project. Add the following line to the angular.json file under the styles array:

"styles": [
  "src/styles.css",
  "node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
]

Step 3: Create a Standalone Component

Angular supports standalone components, a modern and streamlined approach for building Angular applications. This example demonstrates using jqxBarGauge in a standalone component.

Complete Example

Below is an example of a standalone Angular component using jqxBarGauge:

// main.ts
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';

bootstrapApplication(AppComponent).catch((err) => console.error(err));

// app.component.ts
import { Component } from '@angular/core';
import { jqxBarGaugeModule } from 'jqwidgets-ng/jqxbargauge';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [jqxBarGaugeModule],
  template: `
    <jqxBarGauge
      [max]="100"
      [values]="values"
      [colorScheme]="'scheme01'"
      (onDrawEnd)="handleDrawEnd($event)"
    ></jqxBarGauge>
  `,
  styles: [
    `
      jqxBarGauge {
        margin: auto;
        display: block;
      }
    `,
  ],
})
export class AppComponent {
  values = [30, 70, 90];

  handleDrawEnd(event: any): void {
    console.log('DrawEnd event triggered:', event);
  }
}

Additional Features

jqxBarGauge offers a wide range of features to enhance your visualizations:

  • Animation: Use the built-in animation support to create smooth transitions for your data visualization.
  • Color Customization: Apply custom color schemes or use predefined ones with the [colorScheme] property.
  • Labels: Configure label positioning and formatting using properties like [labels] and [formatFunction].
  • Dynamic Updates: Update the values dynamically by binding the [values] property to your application data model.
  • Tooltips: Enable and customize tooltips for each bar using the [tooltip] property.

Event Handling

jqxBarGauge emits various events to help you create interactive applications. For example:

<jqxBarGauge
  [values]="values"
  (onDrawEnd)="handleDrawEnd($event)"
  (onValueChanged)="handleValueChanged($event)"
></jqxBarGauge>

In the component class:

handleDrawEnd(event: any): void {
  console.log('DrawEnd event:', event);
}

handleValueChanged(event: any): void {
  console.log('ValueChanged event:', event);
}

Conclusion

With this guide, you can seamlessly integrate jqxBarGauge into your Angular applications. Its customizable features and event-handling capabilities make it a great choice for data visualization. For more details and advanced usage, visit the jqWidgets documentation.